Blame


1 0e673013 2019-01-02 stsp #!/bin/sh
2 0e673013 2019-01-02 stsp #
3 5aa81393 2020-01-06 stsp # Copyright (c) 2019, 2020 Stefan Sperling <stsp@openbsd.org>
4 0e673013 2019-01-02 stsp #
5 0e673013 2019-01-02 stsp # Permission to use, copy, modify, and distribute this software for any
6 0e673013 2019-01-02 stsp # purpose with or without fee is hereby granted, provided that the above
7 0e673013 2019-01-02 stsp # copyright notice and this permission notice appear in all copies.
8 0e673013 2019-01-02 stsp #
9 0e673013 2019-01-02 stsp # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 0e673013 2019-01-02 stsp # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 0e673013 2019-01-02 stsp # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 0e673013 2019-01-02 stsp # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 0e673013 2019-01-02 stsp # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 0e673013 2019-01-02 stsp # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 0e673013 2019-01-02 stsp # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
16 0e673013 2019-01-02 stsp
17 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_NAME="Flan Hacker"
18 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_EMAIL="flan_hacker@openbsd.org"
19 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_NAME="$GIT_AUTHOR_NAME"
20 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_EMAIL="$GIT_AUTHOR_EMAIL"
21 0b2899f8 2019-08-18 stsp export GOT_AUTHOR="$GIT_AUTHOR_NAME <$GIT_AUTHOR_EMAIL>"
22 82f6abb8 2019-08-14 stsp export GOT_AUTHOR_8="flan_hac"
23 e600f124 2021-03-21 stsp export GOT_AUTHOR_11="flan_hacker"
24 b1ebc001 2019-08-13 stsp export GOT_LOG_DEFAULT_LIMIT=0
25 11f4fa81 2020-10-01 stsp export GOT_TEST_ROOT="/tmp"
26 c3754a5b 2019-05-10 stsp
27 7b67836a 2019-05-10 stsp export MALLOC_OPTIONS=S
28 d3b82051 2022-07-10 thomas
29 d3b82051 2022-07-10 thomas # Check to see if PLATFORM has a value. PLATFORM is populated when running
30 d3b82051 2022-07-10 thomas # via `./configure && make` but this isn't guaranteed if an individual test is
31 d3b82051 2022-07-10 thomas # run directly, such as `regress/cmdline/tag.sh`. In such cases, PLATFORM
32 d3b82051 2022-07-10 thomas # will be empty, but we still want to use it. Since we test for non-linux
33 d3b82051 2022-07-10 thomas # values, only set PLATFORM if we're running on Linu so that the correct
34 d3b82051 2022-07-10 thomas # commands are used.
35 d3b82051 2022-07-10 thomas [ -z "$PLATFORM" ] && [ "$OSTYPE" = "linux-gnu" ] && PLATFORM="linux"
36 7b67836a 2019-05-10 stsp
37 fa37079f 2021-10-09 thomas date()
38 fa37079f 2021-10-09 thomas {
39 fa37079f 2021-10-09 thomas DATECMD="date"
40 e8da6c41 2022-07-10 thomas [ "$PLATFORM" != "linux" ] && {
41 e8da6c41 2022-07-10 thomas command -v "gdate" >/dev/null 2>&1 && {
42 e8da6c41 2022-07-10 thomas DATECMD="gdate"
43 e8da6c41 2022-07-10 thomas } || {
44 e8da6c41 2022-07-10 thomas echo "Couldn't find `gdate` is GNU coreutils installed?"
45 e8da6c41 2022-07-10 thomas }
46 e8da6c41 2022-07-10 thomas }
47 c206b220 2021-10-09 thomas command "$DATECMD" "$@"
48 fa37079f 2021-10-09 thomas }
49 fa37079f 2021-10-09 thomas
50 fa37079f 2021-10-09 thomas ln()
51 fa37079f 2021-10-09 thomas {
52 fa37079f 2021-10-09 thomas LNCMD="ln"
53 e8da6c41 2022-07-10 thomas [ "$PLATFORM" != "linux" ] && {
54 e8da6c41 2022-07-10 thomas command -v "gln" >/dev/null 2>&1 && {
55 e8da6c41 2022-07-10 thomas LNCMD="gln"
56 e8da6c41 2022-07-10 thomas } || {
57 e8da6c41 2022-07-10 thomas echo "Couldn't find `gln` is GNU coreutils installed?"
58 e8da6c41 2022-07-10 thomas }
59 e8da6c41 2022-07-10 thomas }
60 c206b220 2021-10-09 thomas command "$LNCMD" "$@"
61 fa37079f 2021-10-09 thomas }
62 fa37079f 2021-10-09 thomas
63 c206b220 2021-10-09 thomas sed()
64 c206b220 2021-10-09 thomas {
65 c206b220 2021-10-09 thomas SEDCMD="sed"
66 186c23b6 2022-03-08 thomas
67 186c23b6 2022-03-08 thomas # On non-linux systems, the sed command can happily accept "-i ''" as
68 186c23b6 2022-03-08 thomas # a valid command to not save backup files for in-place edits.
69 186c23b6 2022-03-08 thomas # However, on linux, "-i ''" would be treated as "-i" with a blank
70 186c23b6 2022-03-08 thomas # argument, and hence, no file to edit in-place, which is an error.
71 186c23b6 2022-03-08 thomas #
72 186c23b6 2022-03-08 thomas # Therefore, scan the argument list and remove "-i ''", replacing it
73 186c23b6 2022-03-08 thomas # with just "-i".
74 1ff9fea4 2021-11-23 thomas [ "$PLATFORM" = "linux" ] && {
75 c206b220 2021-10-09 thomas set -- "$@"
76 186c23b6 2022-03-08 thomas i=1
77 186c23b6 2022-03-08 thomas while [ "$i" -le "$#" ]; do
78 186c23b6 2022-03-08 thomas m=$((i + 1))
79 186c23b6 2022-03-08 thomas [ "${!i}" = "-i" ] && [ -z "${!m}" ] && {
80 186c23b6 2022-03-08 thomas shift 2
81 186c23b6 2022-03-08 thomas command "$SEDCMD" -i "$@"
82 186c23b6 2022-03-08 thomas return
83 186c23b6 2022-03-08 thomas }
84 186c23b6 2022-03-08 thomas i=$((i + 1))
85 186c23b6 2022-03-08 thomas done
86 c206b220 2021-10-09 thomas }
87 c206b220 2021-10-09 thomas command "$SEDCMD" "$@"
88 c206b220 2021-10-09 thomas }
89 fa37079f 2021-10-09 thomas
90 fa37079f 2021-10-09 thomas
91 f6cae3ed 2020-09-13 naddy git_init()
92 0e673013 2019-01-02 stsp {
93 0b2899f8 2019-08-18 stsp git init -q "$1"
94 f60607c8 2021-09-30 thomas
95 f60607c8 2021-09-30 thomas # Switch the default branch to match our test expectations if needed.
96 f60607c8 2021-09-30 thomas # Only need to change HEAD since 'git init' did not create any refs.
97 f60607c8 2021-09-30 thomas # Relying on implementation details of 'git init' is no problem for us.
98 f60607c8 2021-09-30 thomas # We want to be alerted when Git changes fundamental assumptions such
99 f60607c8 2021-09-30 thomas # as what an empty repository looks like and where the default branch
100 f60607c8 2021-09-30 thomas # is set. In such cases Got's own tooling might well need to change
101 f60607c8 2021-09-30 thomas # its behaviour, too, and our tests should fail.
102 f60607c8 2021-09-30 thomas # TODO: Update all tests to assume 'main' instead of 'master' and
103 f60607c8 2021-09-30 thomas # switch to main here, to match Got's own default.
104 f60607c8 2021-09-30 thomas echo "ref: refs/heads/master" > "$1/.git/HEAD"
105 0e673013 2019-01-02 stsp }
106 0e673013 2019-01-02 stsp
107 f6cae3ed 2020-09-13 naddy maybe_pack_repo()
108 b32c4525 2020-01-05 stsp {
109 b32c4525 2020-01-05 stsp local repo="$1"
110 b32c4525 2020-01-05 stsp if [ -n "$GOT_TEST_PACK" ]; then
111 b32c4525 2020-01-05 stsp (cd $repo && git repack -a -q)
112 b32c4525 2020-01-05 stsp fi
113 b32c4525 2020-01-05 stsp }
114 b32c4525 2020-01-05 stsp
115 f6cae3ed 2020-09-13 naddy git_commit()
116 0e673013 2019-01-02 stsp {
117 0e673013 2019-01-02 stsp local repo="$1"
118 0e673013 2019-01-02 stsp shift
119 0b2899f8 2019-08-18 stsp (cd $repo && git commit --author="$GOT_AUTHOR" -q -a "$@")
120 b32c4525 2020-01-05 stsp maybe_pack_repo $repo
121 0e673013 2019-01-02 stsp }
122 0e673013 2019-01-02 stsp
123 f6cae3ed 2020-09-13 naddy git_rm()
124 512f0d0e 2019-01-02 stsp {
125 512f0d0e 2019-01-02 stsp local repo="$1"
126 512f0d0e 2019-01-02 stsp shift
127 512f0d0e 2019-01-02 stsp (cd $repo && git rm -q "$@")
128 512f0d0e 2019-01-02 stsp }
129 512f0d0e 2019-01-02 stsp
130 f6cae3ed 2020-09-13 naddy git_show_head()
131 9c4b8182 2019-01-02 stsp {
132 9c4b8182 2019-01-02 stsp local repo="$1"
133 9c4b8182 2019-01-02 stsp (cd $repo && git show --no-patch --pretty='format:%H')
134 9c4b8182 2019-01-02 stsp }
135 9c4b8182 2019-01-02 stsp
136 f6cae3ed 2020-09-13 naddy git_show_branch_head()
137 db32465d 2020-02-07 stsp {
138 db32465d 2020-02-07 stsp local repo="$1"
139 db32465d 2020-02-07 stsp local branch="$2"
140 db32465d 2020-02-07 stsp (cd $repo && git show --no-patch --pretty='format:%H' $branch)
141 db32465d 2020-02-07 stsp }
142 db32465d 2020-02-07 stsp
143 db32465d 2020-02-07 stsp
144 f6cae3ed 2020-09-13 naddy git_show_author_time()
145 bcb49d15 2019-08-14 stsp {
146 bcb49d15 2019-08-14 stsp local repo="$1"
147 01073a5d 2019-08-22 stsp local object="$2"
148 01073a5d 2019-08-22 stsp (cd $repo && git show --no-patch --pretty='format:%at' $object)
149 bcb49d15 2019-08-14 stsp }
150 bcb49d15 2019-08-14 stsp
151 f6cae3ed 2020-09-13 naddy git_show_tagger_time()
152 8e7bd50a 2019-08-22 stsp {
153 8e7bd50a 2019-08-22 stsp local repo="$1"
154 8e7bd50a 2019-08-22 stsp local tag="$2"
155 8e7bd50a 2019-08-22 stsp (cd $repo && git cat-file tag $tag | grep ^tagger | \
156 8e7bd50a 2019-08-22 stsp sed -e "s/^tagger $GOT_AUTHOR//" | cut -d' ' -f2)
157 8e7bd50a 2019-08-22 stsp }
158 8e7bd50a 2019-08-22 stsp
159 f6cae3ed 2020-09-13 naddy git_show_parent_commit()
160 818c7501 2019-07-11 stsp {
161 818c7501 2019-07-11 stsp local repo="$1"
162 70551d57 2020-04-24 stsp local commit="$2"
163 70551d57 2020-04-24 stsp (cd $repo && git show --no-patch --pretty='format:%P' $commit)
164 818c7501 2019-07-11 stsp }
165 818c7501 2019-07-11 stsp
166 f6cae3ed 2020-09-13 naddy git_show_tree()
167 03415a1a 2019-06-02 stsp {
168 03415a1a 2019-06-02 stsp local repo="$1"
169 03415a1a 2019-06-02 stsp (cd $repo && git show --no-patch --pretty='format:%T')
170 03415a1a 2019-06-02 stsp }
171 03415a1a 2019-06-02 stsp
172 f6cae3ed 2020-09-13 naddy trim_obj_id()
173 818c7501 2019-07-11 stsp {
174 9439a990 2020-09-16 naddy local trimcount=$1
175 9439a990 2020-09-16 naddy local id=$2
176 818c7501 2019-07-11 stsp
177 9439a990 2020-09-16 naddy local pat=""
178 9439a990 2020-09-16 naddy while [ "$trimcount" -gt 0 ]; do
179 818c7501 2019-07-11 stsp pat="[0-9a-f]$pat"
180 9439a990 2020-09-16 naddy trimcount=$((trimcount - 1))
181 818c7501 2019-07-11 stsp done
182 818c7501 2019-07-11 stsp
183 818c7501 2019-07-11 stsp echo ${id%$pat}
184 818c7501 2019-07-11 stsp }
185 818c7501 2019-07-11 stsp
186 f6cae3ed 2020-09-13 naddy git_commit_tree()
187 03415a1a 2019-06-02 stsp {
188 03415a1a 2019-06-02 stsp local repo="$1"
189 03415a1a 2019-06-02 stsp local msg="$2"
190 03415a1a 2019-06-02 stsp local tree="$3"
191 03415a1a 2019-06-02 stsp (cd $repo && git commit-tree -m "$msg" "$tree")
192 03415a1a 2019-06-02 stsp }
193 03415a1a 2019-06-02 stsp
194 f0fd0aaf 2021-09-14 stsp git_fsck()
195 f0fd0aaf 2021-09-14 stsp {
196 f0fd0aaf 2021-09-14 stsp local testroot="$1"
197 f0fd0aaf 2021-09-14 stsp local repo="$2"
198 f0fd0aaf 2021-09-14 stsp
199 f0fd0aaf 2021-09-14 stsp (cd $repo && git fsck --strict \
200 f0fd0aaf 2021-09-14 stsp > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
201 fc414659 2022-04-16 thomas ret=$?
202 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
203 f0fd0aaf 2021-09-14 stsp echo -n "git fsck: "
204 f0fd0aaf 2021-09-14 stsp cat $testroot/fsck.stderr
205 f0fd0aaf 2021-09-14 stsp echo "git fsck failed; leaving test data in $testroot"
206 f0fd0aaf 2021-09-14 stsp return 1
207 f0fd0aaf 2021-09-14 stsp fi
208 f0fd0aaf 2021-09-14 stsp
209 f0fd0aaf 2021-09-14 stsp return 0
210 f0fd0aaf 2021-09-14 stsp }
211 f0fd0aaf 2021-09-14 stsp
212 f6cae3ed 2020-09-13 naddy make_test_tree()
213 0e673013 2019-01-02 stsp {
214 0e673013 2019-01-02 stsp repo="$1"
215 0e673013 2019-01-02 stsp
216 0e673013 2019-01-02 stsp echo alpha > $repo/alpha
217 0e673013 2019-01-02 stsp echo beta > $repo/beta
218 0e673013 2019-01-02 stsp mkdir $repo/gamma
219 0e673013 2019-01-02 stsp echo delta > $repo/gamma/delta
220 0e673013 2019-01-02 stsp mkdir $repo/epsilon
221 0e673013 2019-01-02 stsp echo zeta > $repo/epsilon/zeta
222 0e673013 2019-01-02 stsp }
223 0e673013 2019-01-02 stsp
224 f6cae3ed 2020-09-13 naddy make_single_file_repo()
225 e7303626 2020-05-14 stsp {
226 e7303626 2020-05-14 stsp repo="$1"
227 e7303626 2020-05-14 stsp file="$2"
228 e7303626 2020-05-14 stsp
229 e7303626 2020-05-14 stsp mkdir $repo
230 e7303626 2020-05-14 stsp git_init $repo
231 e7303626 2020-05-14 stsp echo "this is file $file" > $repo/$file
232 e7303626 2020-05-14 stsp (cd $repo && git add .)
233 e7303626 2020-05-14 stsp git_commit $repo -m "intialize $repo with file $file"
234 e7303626 2020-05-14 stsp }
235 e7303626 2020-05-14 stsp
236 f6cae3ed 2020-09-13 naddy get_loose_object_path()
237 e7303626 2020-05-14 stsp {
238 e7303626 2020-05-14 stsp local repo="$1"
239 e7303626 2020-05-14 stsp local id="$2"
240 e7303626 2020-05-14 stsp local id0=`trim_obj_id 38 $id`
241 e7303626 2020-05-14 stsp local idrest=`echo ${id#[0-9a-f][0-9a-f]}`
242 e7303626 2020-05-14 stsp echo "$repo/.git/objects/$id0/$idrest"
243 e7303626 2020-05-14 stsp }
244 e7303626 2020-05-14 stsp
245 f6cae3ed 2020-09-13 naddy get_blob_id()
246 3ce1b845 2019-07-15 stsp {
247 3ce1b845 2019-07-15 stsp repo="$1"
248 3ce1b845 2019-07-15 stsp tree_path="$2"
249 3ce1b845 2019-07-15 stsp filename="$3"
250 3ce1b845 2019-07-15 stsp
251 e8863bdc 2020-07-23 stsp got tree -r $repo -i $tree_path | grep "[0-9a-f] ${filename}$" | \
252 e8863bdc 2020-07-23 stsp cut -d' ' -f 1
253 3ce1b845 2019-07-15 stsp }
254 3ce1b845 2019-07-15 stsp
255 f6cae3ed 2020-09-13 naddy test_init()
256 0e673013 2019-01-02 stsp {
257 0e673013 2019-01-02 stsp local testname="$1"
258 4a1ddfc2 2019-01-12 stsp local no_tree="$2"
259 0e673013 2019-01-02 stsp if [ -z "$testname" ]; then
260 0e673013 2019-01-02 stsp echo "No test name provided" >&2
261 0e673013 2019-01-02 stsp return 1
262 0e673013 2019-01-02 stsp fi
263 e5a14fe3 2020-10-01 stsp local testroot=`mktemp -d "$GOT_TEST_ROOT/got-test-$testname-XXXXXXXX"`
264 0e673013 2019-01-02 stsp mkdir $testroot/repo
265 0e673013 2019-01-02 stsp git_init $testroot/repo
266 4a1ddfc2 2019-01-12 stsp if [ -z "$no_tree" ]; then
267 4a1ddfc2 2019-01-12 stsp make_test_tree $testroot/repo
268 3ce1b845 2019-07-15 stsp (cd $repo && git add .)
269 4a1ddfc2 2019-01-12 stsp git_commit $testroot/repo -m "adding the test tree"
270 4a1ddfc2 2019-01-12 stsp fi
271 c8c71e6e 2020-03-21 stsp touch $testroot/repo/.git/git-daemon-export-ok
272 0e673013 2019-01-02 stsp echo "$testroot"
273 0e673013 2019-01-02 stsp }
274 0e673013 2019-01-02 stsp
275 f6cae3ed 2020-09-13 naddy test_cleanup()
276 0e673013 2019-01-02 stsp {
277 0e673013 2019-01-02 stsp local testroot="$1"
278 fe7842f5 2019-07-14 stsp
279 f0fd0aaf 2021-09-14 stsp git_fsck $testroot $testroot/repo
280 fc414659 2022-04-16 thomas ret=$?
281 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
282 f0fd0aaf 2021-09-14 stsp return $ret
283 fe7842f5 2019-07-14 stsp fi
284 fe7842f5 2019-07-14 stsp
285 0e673013 2019-01-02 stsp rm -rf "$testroot"
286 0e673013 2019-01-02 stsp }
287 0e673013 2019-01-02 stsp
288 f6cae3ed 2020-09-13 naddy test_parseargs()
289 7fb414ae 2020-08-08 stsp {
290 6c8da0c6 2020-10-03 naddy while getopts qr: flag; do
291 6c8da0c6 2020-10-03 naddy case $flag in
292 6c8da0c6 2020-10-03 naddy q) export GOT_TEST_QUIET=1
293 6c8da0c6 2020-10-03 naddy ;;
294 6c8da0c6 2020-10-03 naddy r) export GOT_TEST_ROOT=$OPTARG
295 6c8da0c6 2020-10-03 naddy ;;
296 6c8da0c6 2020-10-03 naddy ?) echo "Supported options:"
297 6c8da0c6 2020-10-03 naddy echo " -q: quiet mode"
298 6c8da0c6 2020-10-03 naddy echo " -r PATH: use PATH as test data root directory"
299 6c8da0c6 2020-10-03 naddy exit 2
300 6c8da0c6 2020-10-03 naddy ;;
301 7fb414ae 2020-08-08 stsp esac
302 7fb414ae 2020-08-08 stsp done
303 6c8da0c6 2020-10-03 naddy } >&2
304 7fb414ae 2020-08-08 stsp
305 f6cae3ed 2020-09-13 naddy run_test()
306 0e673013 2019-01-02 stsp {
307 0e673013 2019-01-02 stsp testfunc="$1"
308 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
309 7fb414ae 2020-08-08 stsp echo -n "$testfunc "
310 7fb414ae 2020-08-08 stsp fi
311 0e673013 2019-01-02 stsp $testfunc
312 0e673013 2019-01-02 stsp }
313 0e673013 2019-01-02 stsp
314 f6cae3ed 2020-09-13 naddy test_done()
315 0e673013 2019-01-02 stsp {
316 0e673013 2019-01-02 stsp local testroot="$1"
317 0e673013 2019-01-02 stsp local result="$2"
318 54c39596 2020-12-28 stsp if [ "$result" = "0" ]; then
319 fe7842f5 2019-07-14 stsp test_cleanup "$testroot" || return 1
320 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
321 7fb414ae 2020-08-08 stsp echo "ok"
322 7fb414ae 2020-08-08 stsp fi
323 3941b73a 2019-05-14 stsp elif echo "$result" | grep -q "^xfail"; then
324 3941b73a 2019-05-14 stsp # expected test failure; test reproduces an unfixed bug
325 3941b73a 2019-05-14 stsp echo "$result"
326 17201126 2019-07-14 stsp test_cleanup "$testroot" || return 1
327 0e673013 2019-01-02 stsp else
328 0e673013 2019-01-02 stsp echo "test failed; leaving test data in $testroot"
329 0e673013 2019-01-02 stsp fi
330 0e673013 2019-01-02 stsp }